#include <stdio.h>
#include <time.h>
#include "../../INCLUDE/const.h"
#include "../../INCLUDE/struct.h"
#include "../../INCLUDE/decl.h"
#include "../../INCLUDE/macros.h"

#ifdef DEBUG_malloc
#ifdef SIMULATION
extern void out_times_info();
#endif
#ifdef REACHABILITY
extern void out_reach_info();
#ifdef SYMBOLIC
extern void out_canonic_info();
#endif
#endif
extern void out_token_info();
extern void out_event_info();
#endif

#ifdef SYMBOLIC
extern void initialize_split_data_structure();
extern void initialize_merge_data_structure();
#endif

#ifdef SIMULATION
extern double floor();
extern int forward_sim();
extern int init_events(); /* Controllare se si puo' usare nel reach */
extern double log();
extern void fill_preselection_rate_field();
#endif
#ifdef REACHABILITY
extern void build_graph();
extern int init_events(); /* Controllare se si puo' usare nel reach */
#endif
extern int get_class_card();
extern int already_exist();
extern int intersection();
extern int read_DEF_file() ;
extern int read_NET_file();
extern int get_max_cardinality();
extern int get_max_place_domain();
extern int get_max_transition_domain();
extern int get_max_colour_repetitions();
extern int get_max_elements();
extern int get_max_cl();
extern void initialize_free_token_list();
extern void initialize_free_event_list();
extern FILE *zzin ;
extern FILE *kkin;
extern FILE *jjin;
extern FILE *zzout ;
extern FILE *kkout;

FILE *mfp ;
FILE *nfp,*nfp2 ;
FILE *pinfp;
FILE *cfp,*sfp;
#ifdef REACHABILITY
FILE *srg;
FILE *rgr_aux;
FILE *wngr;
FILE *ctrs;
FILE *grg;
FILE *string;
#ifdef SYMBOLIC
FILE *f_cap_fp;
FILE *value_fp;
FILE *min_value_fp;
#endif
#endif


#ifdef SIMULATION

#define TRANS_LENGTH 1000
#define MIN_BATCH_LENGTH 1000
#define MAX_BATCH_LENGTH 2000
#define APPROX_DEGREE 15
#define CONF_LEVEL 4

int seed = 31415;

/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void create_statistics_data_structure(ok)
 int ok;
 {/* Init create_statistics_data_structure */
  int ind;
  char name[MAX_TAG_SIZE];

  if(ok)
   {/* Il file .stat e' presente */
#ifdef GREATSPN
    for(ind = 0; ind < npl; ind++)
     tabp[ind].tagged = FALSE;
    for(ind = 0; ind < ntr; ind++)
     tabt[ind].tagged = FALSE;
#endif
    while( TRUE )
     {
      fscanf(pinfp,"%s",&name);
      if(isalpha(name[0]))
       {/* Non e' una lettera dell'alfabeto */
	ind = get_tr_in(name);
	if(ind == UNKNOWN)
	 {
	  ind = get_pl_in(name);
	  if(ind == UNKNOWN)
	   fprintf(stdout,"Warning: unknown name %s in file .stat\n",name);
	  else
	   tabp[ind].tagged = TRUE;
	 }
	else
	 tabt[ind].tagged = TRUE;
       }/* Non e' una lettera dell'alfabeto */
      getc(pinfp);
      if(feof(pinfp))
       break;
     }
   }/* Il file .stat e' presente */
 }/* End create_statistics_data_structure */
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int belong(pl,list)
 int pl;
 Node_p list;
 {/* Init belong */
  Node_p p = NULL;

  for(p = list; p!= NULL ; p = NEXT_NODE(p))
   if(p->place_no == pl)
    return(TRUE);
  return(FALSE);
 }/* End belong */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int inters(list1,list2)
 Node_p list1;
 Node_p list2;
 {/* Init inters */
  Node_p p1 = NULL;

  if( list1 == NULL || list2 == NULL)
   return(FALSE);
  for( p1 = list1; p1 != NULL ; p1 = NEXT_NODE(p1))
   if(belong(p1->place_no,list2))
    return(TRUE);
  return(FALSE);
 }/* End inters */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int CC_SC_belong(pl,list,tr)
 int pl;
 Node_p list;
 int tr;
 {/* Init CC_SC_belong */
  Node_p p = NULL;
  int ret_value = FALSE;

  for(p = list; p!= NULL ; p = NEXT_NODE(p))
   if(p->place_no == pl )
    {
     ret_value = TRUE;
#ifdef SIMULATION
     if(IS_SKIPPABLE(tr))
      p->involved_in_CC_SC = TRUE;
#endif
    }
  return(ret_value);
 }/* End CC_SC_belong */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int CC_SC_inters(list1,list2,tr1,tr2)
 Node_p list1;
 Node_p list2;
 int tr1;
 int tr2;
 {/* Init CC_SC_inters */
  Node_p p1 = NULL;
  int ret_value = FALSE;

  if( !( list1 == NULL || list2 == NULL))
   for( p1 = list1; p1 != NULL ; p1 = NEXT_NODE(p1))
    if(CC_SC_belong(p1->place_no,list2,tr2))
     {
      ret_value = TRUE;
#ifdef SIMULATION
      if(IS_SKIPPABLE(tr2))
       p1->involved_in_CC_SC = TRUE;
#endif
     }
  return(ret_value);
 }/* End CC_SC_inters */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void get_CC_SC_relations()
 {/* Init get_CC_SC_relations */
  int tr1,tr2,num_cc,num_sc,trans_cc[MAX_TRANS],trans_sc[MAX_TRANS];
  int int1,int2;

  for(tr1=0;tr1<ntr;tr1++)
   {/* Per ogni transizione */
    for(tr2=ntr-1,num_cc=num_sc=0;tr2>=0;tr2--)
     {/* Main loop */
      if(tr1!=tr2)
       {/* Transizioni diverse */
	int1 = CC_SC_inters(tabt[tr1].inptr,tabt[tr2].inptr,tr1,tr2);
	int2 = CC_SC_inters(tabt[tr1].outptr,tabt[tr2].inibptr,tr1,tr2);
	if(int1 || int2)
	 trans_sc[num_sc++]=tr2;
	int1 = CC_SC_inters(tabt[tr1].inptr,tabt[tr2].inibptr,tr1,tr2);
	int2 = CC_SC_inters(tabt[tr1].outptr,tabt[tr2].inptr,tr1,tr2);
	if(int1 || int2)
	 trans_cc[num_cc++]=tr2;
       }/* Transizioni diverse */
     }/* Main loop */
    /* Write on cc */
    fprintf(cfp,"%d ",num_cc);
    for(;num_cc;num_cc--)
     fprintf(cfp,"%d ",trans_cc[num_cc-1]+1);
    fprintf(cfp,"\n");
    /* Write on sc */
    fprintf(sfp,"%d ",num_sc);
    for(;num_sc;num_sc--)
     fprintf(sfp,"%d ",trans_sc[num_sc-1]+1);
    fprintf(sfp,"\n");
   }/* Per ogni transizione */
 }/* End get_CC_SC_relations */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
char *emalloc ( sz )
 unsigned sz;
 {/* Init emalloc */
  extern char * malloc();
  char * callptr;
 
  if ((callptr = malloc(sz)) == NULL)
   {/* Errore */
    fprintf(stdout,"Runtime Error: emalloc: couldn't fill request for %d\n", sz );
    exit(1);
   }/* Errore */
  return(callptr);
 }/* End emalloc */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
FILE *efopen ( file, mode )
 char file[MAX_STRING_LENGTH],mode[5];
 {/* Init efopen */
  extern FILE *fopen();
  FILE *callptr;
 
  if ((callptr = fopen(file, mode)) == NULL)
   {/* Errore */
    fprintf(stdout,"Runtime Error: fopen couldn't open %s, in mode %s\n",file, mode );
    exit(1);
   }/* Errore */
  return(callptr);
 }/* End efopen */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
char *ecalloc ( nitm, sz )
 unsigned nitm, sz;
 {/* Init ecalloc */
  extern char * calloc();
  char * callptr;
 
  if ((callptr = calloc(nitm, sz)) == NULL)
   {/* Errore */
    fprintf(stdout,"Runtime Error : ecalloc couldn't fill request for %d, %d\n",nitm, sz );
    exit(1);
   }/* Errore */
  return(callptr);
 }/* End ecalloc */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_pl_in(pl_name)
 char pl_name[MAX_TAG_SIZE];
 {/* Init get_pl_in */
  int i,ret=UNKNOWN;

  for(i = 0 ; i < npl ; i++)
   if(!strcmp(pl_name,tabp[i].place_name))
    {
     ret = i;
     break;
    }
  return(ret);
 }/* End get_pl_in */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void fill_CC_SC_data_structure(ok_me)
 int ok_me;
 {/* Init fill_CC_SC_data_structure */
  int *usp;
  int ii,jj,na,nc;
  char trans_nm[MAX_TAG_SIZE];

  for(ii=0;ii<ntr;ii++)
   {
    fscanf(cfp," %d", &na );
    tabt[ii].add_l = usp = (int *)ecalloc(na+1,sizeof(int));
    *(usp += na) = UNKNOWN;
    while ( na-- ) 
     {
      fscanf(cfp,"%d", &jj );
      *(--usp) = jj - 1;
     }
    while ( getc(cfp) != '\n' );
   }
  for(ii=0;ii<ntr;ii++)
   {
    fscanf(sfp,"%d", &nc );
    tabt[ii].test_l = usp = (int*)ecalloc(nc+1,sizeof(int));
    *(usp += nc) = UNKNOWN;
    while ( nc-- ) 
     {
      fscanf(sfp,"%d", &jj );
      *(--usp) = jj - 1;
     }
    while ( getc(sfp) != '\n' );
   }
  for(ii = 0 ; ii < ntr ; ii++)
   tabt[ii].me_l = NULL;
  if(ok_me)
   {/* Lettura file di me */
    int ind;

    while( TRUE )
     {
      fscanf(pinfp," %s",&trans_nm);
      fscanf(pinfp," %d",&na);
      ind = get_tr_in(trans_nm);
      if(ind == UNKNOWN)
       out_error(ERROR_UNKNOWN_TRANSITION_NAME,0,0,0,0,trans_nm,NULL);
      tabt[ind].me_l = usp = (int *)ecalloc(na+1,sizeof(int));
      *(usp += na) = UNKNOWN;
      while ( na-- )
       {
	fscanf(pinfp,"%s",&trans_nm);
	ind = get_tr_in(trans_nm);
	if(ind == UNKNOWN)
	 out_error(ERROR_UNKNOWN_TRANSITION_NAME,0,0,0,0,trans_nm,NULL);
	*(--usp) = ind;
       }
      getc(pinfp);
      if( feof(pinfp))
       break;
     }
   }/* Lettura file di me */
 }/* End fill_CC_SC_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int get_tr_in(tr_name)
 char tr_name[MAX_TAG_SIZE];
 {/* Init get_tr_in */
  int i,ret = UNKNOWN;

  for( i = 0 ; i < ntr ; i++)
   if(!strcmp(tr_name,tabt[i].trans_name))
    {
     ret = i;
     break;
    }
  return(ret);
 }/* End get_tr_in */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void create_marking_data_structure()
 {/* Init create_marking_data_structure */
  int i;

  initialize_free_token_list();
  net_mark = (Net_Mark_p)ecalloc(npl,sizeof(struct NET_MARKING));
  for(i=0;i<npl;i++)
   {/* Per ogni posto */
    net_mark[i].marking = NULL;
    net_mark[i].total = 0;
    net_mark[i].different = 0;
#ifdef SYMBOLIC
    net_mark[i].ordinary = 0;
#endif
#ifdef SIMULATION
    net_mark[i].touched_h = NULL;
    net_mark[i].reset_h = NULL;
    net_mark[i].touched_t = NULL;
    net_mark[i].reset_t = NULL;
#ifdef SYMBOLIC
    net_mark[i].group = NULL;
#endif
    net_mark[i].num_of_touched = 0;
    net_mark[i].num_of_reset = 0;
#endif
    if(IS_NEUTRAL(i))
     {/* Posto neutro */
      Token_p mark_ptr = NULL;

      mark_ptr = (Token_p)emalloc(sizeof(struct COLOURED_TOKEN));
      mark_ptr->id = NULL;
      mark_ptr->molt = 0;
      net_mark[i].marking = mark_ptr;
     }/* Posto neutro */
   }/* Per ogni posto */
 }/* End create_marking_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void fill_marking_data_structure()
 {/* Init fill_marking_data_structure */
  int i,h;

  for(i=0;i<npl;i++)
   {/* Per ogni posto */
    if(tabp[i].position < 0)
     {/* Posto marcato */
      if(tabp[i].position<-10000)
       {/* Posto colorato marcato */
	pl_ind = i; /* pl_ind e' usato nella grammatica */
	for(h=0;h<nmr && tabm[h].position!=-((tabp[i].position)+10000);h++);
	fseek(mfp,tabm[h].file_pos,SEEK_SET);
	num_of_token=1;
	jjin=mfp;
	parser();
#ifdef SIMULATION
	net_mark[pl_ind].touched_h = net_mark[pl_ind].touched_t = NULL;
	net_mark[pl_ind].reset_h = net_mark[pl_ind].reset_t = NULL;
        net_mark[i].num_of_touched = net_mark[i].num_of_reset = 0;
#endif
       }/* Posto colorato marcato */
      else
       {/* Posto neutro marcato */
	net_mark[i].total = tabmp[-(tabp[i].position)-1].mark_val;
	if(IS_FULL(i))
	 {
	  net_mark[i].different = 1;
#ifdef SYMBOLIC
	  net_mark[i].ordinary = 1;
#endif
	 }
	SET_TOKEN_MOLTEPLICITY(net_mark[i].total,net_mark[i].marking);
       }/* Posto neutro marcato */
     }/* Posto marcato */
    else
     if(IS_NEUTRAL(i))
      {/* Posto neutro */
       net_mark[i].total = tabp[i].position;
       if(IS_FULL(i))
	{
	 net_mark[i].different = 1;
#ifdef SYMBOLIC
	 net_mark[i].ordinary = 1;
#endif
	}
       SET_TOKEN_MOLTEPLICITY(net_mark[i].total , net_mark[i].marking);
      }/* Posto neutro */
   }/* Per ogni posto */
 }/* End fill_marking_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int compare_class(c1,c2)
 struct COLORS *c1;
 struct COLORS *c2;
 {/* Init compare_class */
  if(c1->type == c2->type)
   return(0);
  else
   if(c1->type == ORDERED)
    return(-1);
   else
    return(1);
 }/* End compare_class */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void  order_color_table()
 {/* Init order_color_table */
  qsort((char *)tabc,ncl,sizeof(struct COLORS),compare_class);
 }/* End order_color_table */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void fill_color_class_data_structure()
 {/* Inizio fill_color_class_data_structure */
  struct SBCBUF *sbptr;
  int sbin,ind,stop,h,disj;

  for(sbptr=buf_list;sbptr!=NULL;sbptr=sbptr->next)
   {/* Scansione lista buffer */
    stop=FALSE;
    for(ind=0;ind<ncl && !stop;ind++)
     if((sbin=already_exist(sbptr->name,ind,STAT))!=0)
      stop=TRUE;
    ind--;
    if(!stop)
     {/* Sottoclasse inesistente */
      out_error(ERROR_UNKNOWN_STATIC_SUBCLASS_NAME,0,0,0,0,sbptr->name,NULL);
     }/* Sottoclasse inesistente */
    else if(tabc[ind].sbclist[sbin-1].card!=0)
	  {/* Ridichiarazione sottoclasse */
	   out_error(ERROR_REDECLARATION,0,0,ind,0,sbptr->name,NULL);
	  }/* Ridichiarazione sottoclasse */
    else 
      {/* Aggiornamento tabella */
       tabc[ind].sbclist[sbin-1].name =
	   (char *)ecalloc(strlen(sbptr->name)+1,sizeof(char));
       strcpy(tabc[ind].sbclist[sbin-1].name,sbptr->name);
       tabc[ind].sbclist[sbin-1].card=sbptr->card;
       if(sbptr->obj_list==NULL)
	{/* Descrizione array-like */
	 tabc[ind].sbclist[sbin-1].obj_list=NULL;
	 tabc[ind].sbclist[sbin-1].low=sbptr->low;
	 tabc[ind].sbclist[sbin-1].obj_name =
	     (char *)ecalloc(strlen(sbptr->obj_name)+1,sizeof(char));
	 strcpy(tabc[ind].sbclist[sbin-1].obj_name,sbptr->obj_name);
	}/* Descrizione array-like */
       else
	{/* Descrizione per enumerazione */
	 tabc[ind].sbclist[sbin-1].low=0;
	 tabc[ind].sbclist[sbin-1].obj_name = NULL;
	 tabc[ind].sbclist[sbin-1].obj_list=sbptr->obj_list;
	}/* Descrizione per enumerazione */
       if((disj=intersection(tabc[ind].sbclist,sbin-1,tabc[ind].sbc_num))<0)
	  {/* Sottoclassi non disgiunte */
           disj++;disj=-disj;
	   out_error(ERROR_INTERSECTION,0,0,ind,0,GET_STATIC_NAME(ind,sbin-1),GET_STATIC_NAME(ind,disj));
	  }/* Sottoclassi non disgiunte */
      }/* Aggiornamento tabella */
    sbc_def_num++;
   }/* Scansione lista buffer */
  if(tot_sbc_num!=sbc_def_num)
   {/* Dichiarazioni non complete */
    out_error(ERROR_INCOMPLETE_DEFINITION,0,0,0,0,NULL,NULL);
   }/* Dichiarazioni non complete */
  else
    for(ind = 0 ; ind < ncl ; ind++)
     {/* Per ogni classe */
      tabc[ind].card = get_class_card(ind);
      for(sbin = 0; sbin < GET_STATIC_SUBCLASS(ind); sbin++)
       {/* Per ogni sottoclasse statica si calcola il campo offset */
	tabc[ind].sbclist[sbin].offset = 0;
	for(h = 0; h < sbin; h++)
	 tabc[ind].sbclist[sbin].offset += tabc[ind].sbclist[h].card;
       }/* Per ogni sottoclasse statica si calcola il campo offset */
     }/* Per ogni classe */
#ifdef SYMBOLIC
  order_color_table();
#endif
 }/* Fine fill_color_class_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void initialize_global_variables()
 {/* Init initialize_global_variables */
  int i;

  nodeptr=NULL;
  buf_list=NULL;
  mbuf=NULL;
  tot_sbc_num=0;
  sbc_def_num=0;
  nmp=0;
  npl=0;
  ntr=0;
  nrp=0;
  nmd=0;
  ncl=0;
  nmr=0;
  ngr=0;
  n_ord=0;
  n_unord=0;
  for(i=0;i<MAX_OBJ;i++) el[i]=0;
 }/* End initialize_global_variables */
#ifdef SYMBOLIC
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void fill_dynamic_subclass_data_structure()
 {/* Init fill_dynamic_subclass_data_structure */
  int ss,ok,cl,par;
  struct MARKBUF *mpt = NULL,*frmpt = NULL;
  struct DYNSC *dpt = NULL;

  for(cl = 0 ; cl < ncl ; cl++) 
   {/* Per ogni classe di colore */
    if(IS_UNORDERED(cl))
     {/* Classe non ordinata */
      RESET_NUM_CL(cl);
      for(ss = 0 ; ss < tabc[cl].sbc_num ; ss++)
       {/* Controllo cardinalita'dsc per ogni sottoclasse */
        RESET_NUM_SS(cl,ss);
        dpt = GET_DYNAMIC_LIST(cl,ss);
        for( ; dpt != NULL ; )
         {/* Per ogni sottoclasse dinamica definita */
	  SET_CARD(cl,ss,GET_NUM_SS(cl,ss),dpt->card);
	  dpt->map = GET_NUM_SS(cl,ss);
	  INCREASE_NUM_SS(cl,ss);
	  INCREASE_NUM_CL(cl);
	  dpt = NEXT_DYNAMIC(dpt);
         }/* Per ogni sottoclasse dinamica definita */
       }/* Controllo cardinalita'dsc per ogni sottoclasse */
     }/* Classe non ordinata */
   }/* Per ogni classe di colore */
  for(mpt = mbuf ; mpt != NULL ; mpt = mpt->next)
   {/* Per ogni sottoclasse dinamica bufferizzata */
    frmpt = mpt;
    for( cl = 0 , ok = FALSE ; !ok && cl < ncl ; cl++)
     if(IS_UNORDERED(cl))
      if(( ss = already_exist(mpt->sbc,cl,STAT)) != 0)
       ok = TRUE;
    if(!ok)
     {/* Errore: una sottoclasse statica non esiste */
      out_error(ERROR_UNEXISTING_SUBCLASS_IN_DYNAMIC,0,0,0,0,mpt->sbc,mpt->name);
     }/* Errore: una sottoclasse statica non esiste */
    else
     {/* La dichiarazione della sottoclasse statica e' corretta */
      cl--; ss--;
      if(!already_exist(mpt->name,cl,ss))
       {/* Corretta per la sottoclasse dinamica */
	dpt=(struct DYNSC *)emalloc(sizeof(struct DYNSC));
	dpt->next = tabc[cl].sbclist[ss].dynlist;
	dpt->card = SET_CARD(cl,ss,GET_NUM_SS(cl,ss),mpt->card);
	dpt->name = (char *)ecalloc(strlen(mpt->name)+1,sizeof(char));
	strcpy(dpt->name,mpt->name);
	tabc[cl].sbclist[ss].dynlist = dpt;
	dpt->map = GET_NUM_SS(cl,ss);
	INCREASE_NUM_SS(cl,ss);
	INCREASE_NUM_CL(cl);
       }/* Corretta per la sottoclasse dinamica */
      else
       {/* Errore: ridichiarazione della stessa sottoclasse dinamica */
	out_error(ERROR_REDECLARATION_DYNAMIC,0,0,0,0,mpt->name,mpt->sbc);
       }/* Errore: ridichiarazione della stessa sottoclasse dinamica */
     }/* La dichiarazione della sottoclasse statica e' corretta */
   }/* Per ogni sottoclasse dinamica bufferizzata */
  for( cl = 0 ; cl < ncl ; cl++)
   {/* Per ogni classe di colore */
    if(IS_UNORDERED(cl))
     {/* Classe non ordinata */
      for( ss = 0 ; ss < tabc[cl].sbc_num ; ss++)
       {/* Controllo cardinalita'dsc per ogni sottoclasse */
        par = 0;
        for(dpt=tabc[cl].sbclist[ss].dynlist;dpt!=NULL;dpt=dpt->next)
         par+=dpt->card;
        if(par > tabc[cl].sbclist[ss].card)
         {/* Errore definizione cardinalita'sottoclassi dinamiche */
	  out_error(ERROR_INCONSISTENT_CARDINALITIES,0,0,cl,ss,NULL,NULL);
         }/* Errore definizione cardinalita'sottoclassi dinamiche */
        if(par < tabc[cl].sbclist[ss].card)
         {/* Manca una sottoclasse dinamica */
	  fprintf(stdout,"WARNING : a default dynamic subclass has been added for static subclass %s\n",tabc[cl].sbclist[ss].name);
	  SET_CARD(cl,ss,GET_NUM_SS(cl,ss),tabc[cl].sbclist[ss].card - par);
	  INCREASE_NUM_SS(cl,ss);
	  INCREASE_NUM_CL(cl);
         }/* Manca una sottoclasse dinamica */
       }/* Controllo cardinalita'dsc per ogni sottoclasse */
     }/* Classe non ordinata */
   }/* Per ogni classe di colore */
 }/* Fine fill_dynamic_subclass_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void create_dynamic_subclass_data_structure()
 {/* Init create_dynamic_subclass_data_structure */
  int i,j;

  if(ncl > 0) 
   {/* C'e' almeno una classe */
    card = (int ***)ecalloc(ncl,sizeof(int **));
    num = (int **)ecalloc(ncl,sizeof(int *));
    tot = (int *)ecalloc(ncl,sizeof(int));
    for (i = 0 ; i < ncl; i++) 
     {
      if(IS_UNORDERED(i))
       {/* Classe non ordinata */
        card[i] = (int **)ecalloc(GET_STATIC_SUBCLASS(i), sizeof(int *));
        num[i] = (int *)ecalloc(GET_STATIC_SUBCLASS(i), sizeof(int));
       }/* Classe non ordinata */
     }
    for (i = 0 ; i < ncl; i++) 
     if(IS_UNORDERED(i))
      for(j = 0; j <GET_STATIC_SUBCLASS(i) ; j++)
       card[i][j] = (int *)ecalloc(GET_STATIC_CARDINALITY(i,j) ,sizeof(int));
   }/* C'e' almeno una classe */
 }/* End create_dynamic_subclass_data_structure */
#endif
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void create_cartesian_product_data_structure()
 {/* Init create_cartesian_product_data_structure */
  int max_dimension = UNKNOWN;
  int ii;

  max_cardinality = get_max_cardinality();
  max_place_domain = get_max_place_domain();
  max_transition_domain = get_max_transition_domain();
  max_colour_repetitions = get_max_colour_repetitions();
  max_cl = get_max_cl();

  if(max_cl > 0)
   pred_val = (int *)ecalloc(max_cl,sizeof(int));

  cart_place_ptr = (Cart_p)emalloc(sizeof(struct CARTESIAN_PRODUCT));
  cart_trans_ptr = (Cart_p)emalloc(sizeof(struct CARTESIAN_PRODUCT));

  if(max_place_domain > 0)
   {
    cart_place_ptr->low = (int *)ecalloc(max_place_domain,sizeof(int));
    cart_place_ptr->up = (int *)ecalloc(max_place_domain,sizeof(int));
    cart_place_ptr->mark = (int **)ecalloc(max_place_domain,sizeof(int *));
    for(ii = 0; ii < max_place_domain; ii++)
     {
      max_dimension = get_max_elements(ii);
      cart_place_ptr->mark[ii] = (int *)ecalloc(max_dimension,sizeof(int));
     }
   }
  else
   {
    cart_place_ptr->low = NULL;
    cart_place_ptr->up = NULL;
    cart_place_ptr->mark = NULL;
   }
  if(max_transition_domain > 0)
   {
    cart_trans_ptr->low = (int *)ecalloc(max_transition_domain,sizeof(int));
    cart_trans_ptr->up = (int *)ecalloc(max_transition_domain,sizeof(int));
    cart_trans_ptr->mark = (int **)ecalloc(max_transition_domain,sizeof(int *));
    for(ii = 0; ii < max_transition_domain; ii++)
#ifdef COLOURED
     cart_trans_ptr->mark[ii] = NULL;
#endif
#ifdef SYMBOLIC
     cart_trans_ptr->mark[ii] = (int *)ecalloc(max_colour_repetitions + 1,sizeof(int));
#endif
   }
  else
   {
    cart_trans_ptr->low = NULL;
    cart_trans_ptr->up = NULL;
    cart_trans_ptr->mark = NULL;
   }
 }/* End create_cartesian_product_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void compose_name(name,path,postfix)
 char *name;
 char *path;
 char *postfix;
 {/* Init compose_name */
#ifdef GREATSPN
 sprintf(name,"%s.%s",path,postfix);
#else
 sprintf(name,"nets/%s.%s",path,postfix);
#endif
 }/* End compose_name */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void remove_command(comm,path,postfix)
 char *comm;
 char *path;
 char *postfix;
 {/* Init remove_command */
#ifdef GREATSPN
 sprintf(comm,"/bin/rm %s.%s",path,postfix);
#else
 sprintf(comm,"/bin/rm nets/%s.%s",path,postfix);
#endif
 }/* End remove_command */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void create_table()
 {/* Init create_table */
  if(nmr > 0)
   tabm = (struct MARKING *)ecalloc(nmr,sizeof(struct MARKING));
  nmr = 0;
  if(nmd > 0)
   tabmd = (struct TRANS_MD_RATE *)ecalloc(nmd,sizeof(struct TRANS_MD_RATE));
  nmd = 0;
  if(ncl > 0)
   tabc = (struct COLORS *)ecalloc(ncl,sizeof(struct COLORS));
  ncl = 0;
 }/* End create_table */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
int main(argc,argv)
 int argc;
 char *argv[];
{
 char net[MAX_STRING_LENGTH],comm[MAX_STRING_LENGTH],cc,*slsh;
 char str[MAX_STRING_LENGTH];
 int i,ii;
 int ok;

#ifdef SIMULATION
 int first_tr_l=TRANS_LENGTH;
 int tr_l=TRANS_LENGTH;
 int min_b=MIN_BATCH_LENGTH;
 int max_b=MAX_BATCH_LENGTH;
 int appr=APPROX_DEGREE;
 int conf_l=CONF_LEVEL;
 int old_conf_l=95;
#endif

 if(argc < 2)
  {
   fprintf(stdout,"\n\n--------------------------------------------------------------------------------------------------\n");
#ifdef SIMULATION
#ifdef COLOURED
   fprintf(stdout,"USE : WNSIM netname [-f first_tr_length][-t tr_length][-m min_btc][-M max_btc][-a approx][-c conf_level][-s seed][-o start]\n");
#endif
#ifdef SYMBOLIC
   fprintf(stdout,"USE : WNSYMB netname [-f first_tr_length][-t tr_length][-m min_btc][-M max_btc][-a approx][-c conf_level][-s seed][-o start]\n");
#endif
#endif
#ifdef REACHABILITY
#ifdef COLOURED
   fprintf(stdout,"USE : WNRG netname [-o]\n");
#endif
#ifdef SYMBOLIC
   fprintf(stdout,"USE : WNSRG netname [-o]\n");
#endif
#endif
   fprintf(stdout,"--------------------------------------------------------------------------------------------------\n\n");
   fprintf(stdout,"Send files netname.net, .def to e-mail address\n");
   fprintf(stdout,"rossano@di.unito.it if you find any bug.\n");
   fprintf(stdout,"--------------------------------------------------------------------------------------------------\n\n");
   exit(1);
  }
 for(ii = 2; ii < argc; ii += 2)
  {/* Lettura delle opzioni */
   if(argv[ii+1] != NULL)
    {/* Comando (forse) corretto */
     cc = argv[ii][1];
     switch(cc)
      {/* Casistica */
#ifdef SIMULATION
       case 'f' : first_tr_l = atoi(argv[ii+1]);
  		  break;
       case 't' : tr_l = atoi(argv[ii+1]);
		  break;
       case 'm' : min_b = atoi(argv[ii+1]);
		  break;
       case 'M' : max_b = atoi(argv[ii+1]);
		  break;
       case 'a' : appr = atoi(argv[ii+1]);
		  break;
       case 'c' : old_conf_l = atoi(argv[ii+1]);
  		  switch(old_conf_l)
  		   {/* Codifica da percent. a offset nella tabella t_student */
		    case 60 : conf_l = 0;
		  	      break;
		    case 70 : conf_l = 1;
		              break;
		    case 80 : conf_l = 2;
			      break;
		    case 90 : conf_l = 3;
			      break;
		    case 95 : conf_l = 4;
			      break;
	  	    case 99 : conf_l = 6;
			      break;
		    default : fprintf(stdout,"Incorrect confidence level value\n",conf_l);
                              break;
		   }/* Codifica da percent. a offset nella tabella t_student */
		  break;
       case 's' : seed = atoi(argv[ii+1]);
		  break;
#endif
       case 'o' : output_flag = TRUE;
#ifdef SIMULATION
		  start = atoi(argv[ii+1]);
#endif
		  break;
       default  : fprintf(stdout,"Unknown option %s\n",argv[ii]);
		  exit(1);
		  break;
      }/* Casistica */
    }/* Comando (forse) corretto */
   else
    {/* Comando sicuramente scorretto */
#ifdef REACHABILITY
     cc = argv[ii][1];
     if(cc != 'o')
      {
       fprintf(stdout,"Unknown option %s\n",argv[ii]);
       exit(1);
      }
     else
      output_flag = TRUE;
#endif
#ifdef SIMULATION
     fprintf(stdout,"Incorrect command line\n");
     exit(1);
#endif
    }/* Comando sicuramente scorretto */
  }/* Lettura delle opzioni */
#ifdef SIMULATION
 if(tr_l <= 0)
  {/* Transitorio errato */
   fprintf(stdout,"Incorrect transitory value %d\n",tr_l);
   exit(1);
  }/* Transitorio errato */
 if(min_b <=0 || max_b <=0)
  {/* limiti errati */
   fprintf(stdout,"Incorrect lower and upper values %d-%d\n",min_b,max_b);
   exit(1);
  }/* limiti errati */
 if(min_b > max_b)
  {/* limiti errati */
   fprintf(stdout,"Error: lower > upper %d-%d\n",min_b,max_b);
   exit(1);
  }/* limiti errati */
 if(seed <=0)
  {/* Seme errato */
   fprintf(stdout,"Incorrect initial seed %d\n",seed);
   exit(1);
  }/* Seme errato */
 if(start < 0)
  {/* Seme errato */
   fprintf(stdout,"Incorrect tracing starting point%d\n",start);
   exit(1);
  }/* Seme errato */
 if(appr <= 0 || appr > 100)
  {/* Grado di approssimazione errato */
   fprintf(stdout,"Incorrect accuracy value %d\n",appr);
   exit(1);
  }/* Grado di approssimazione errato */
#endif
 fprintf(stdout,"\n\n--------------------------------------------------------------------------------------------------\n");
#ifdef SIMULATION
#ifdef COLOURED
   fprintf(stdout,"USE : WNSIM netname [-f first_tr_length][-t tr_length][-m min_btc][-M max_btc][-a approx][-c conf_level][-s seed][-o start]\n");
#endif
#ifdef SYMBOLIC
   fprintf(stdout,"USE : WNSYMB netname [-f first_tr_length][-t tr_length][-m min_btc][-M max_btc][-a approx][-c conf_level][-s seed][-o start]\n");
#endif
#endif
#ifdef REACHABILITY
#ifdef COLOURED
   fprintf(stdout,"USE : WNRG netname [-o]\n");
#endif
#ifdef SYMBOLIC
   fprintf(stdout,"USE : WNSRG netname [-o]\n");
#endif
#endif
 fprintf(stdout,"--------------------------------------------------------------------------------------------------\n\n");
 fprintf(stdout,"Send files netname.net, .def to e-mail address\n");
 fprintf(stdout,"rossano@di.unito.it if you find any bug.\n");
 fprintf(stdout,"--------------------------------------------------------------------------------------------------\n\n");

 initialize_global_variables();

/* LETTURA DEL FILE .def E CREAZIONE DEL .net CON SOSTITUZIONE DELLE MACRO */
 compose_name(net,argv[1],"def");
 zzin = efopen(net,"r") ;
 zzout = efopen("/dev/null","w") ;
 parse_DEF = FALSE;
 read_DEF_file();			   /* OPERAZIONI */
 create_table();
 fclose(zzin);
 fclose(zzout);

 compose_name(net,argv[1],"def");
 zzin = efopen(net,"r") ;
 zzout = efopen("/dev/null","w") ;
 compose_name(net,argv[1],"mfp");
 mfp = efopen(net,"a") ;
 compose_name(net,argv[1],"net2");
 nfp2 = efopen(net,"w") ;

 parse_DEF = TRUE;
 read_DEF_file();			   /* OPERAZIONI */
 fill_color_class_data_structure();	   /* OPERAZIONI */
#ifdef SYMBOLIC
 create_dynamic_subclass_data_structure(); /* OPERAZIONI */
 fill_dynamic_subclass_data_structure();   /* OPERAZIONI */
#endif

 fclose(zzin);
 fclose(zzout);
 fclose(nfp2);
 fclose(mfp);

/* LETTURA DEL FILE .def E CREAZIONE DEL .net CON SOSTITUZIONE DELLE MACRO */

/* LETTURA DEL FILE .net E DELLA MARCATURA INIZIALE */

#ifdef GREATSPN
 sprintf(comm,"cat %s.net2 %s.net > %s.ntp",argv[1],argv[1],argv[1]);
#else
 sprintf(comm,"cat nets/%s.net2 nets/%s.net > nets/%s.ntp",argv[1],argv[1],argv[1]);
#endif
 system(comm);
 remove_command(comm,argv[1],"net2");
 system(comm);
#ifdef GREATSPN
 sprintf(comm,"cpp %s.ntp > %s.par",argv[1],argv[1]);
#else
 sprintf(comm,"cpp nets/%s.ntp > nets/%s.par",argv[1],argv[1]);
#endif
 system(comm);
 remove_command(comm,argv[1],"ntp");
 system(comm);
 compose_name(net,argv[1],"par");
 kkin = efopen(net,"rt") ;
 kkout = efopen("/dev/null","w") ;
 compose_name(net,argv[1],"mfp");
 mfp = efopen(net,"r");
 compose_name(net,argv[1],"stat");
 ok=((pinfp = fopen(net,"r")) != NULL) ;

 read_NET_file() ;		    /* OPERAZIONI */
 initialize_free_event_list();

/* DIMENSIONAMENTO DELLE STRUTTURE DATI DEL PRODOTTO CARTESIANO */
 create_cartesian_product_data_structure();
/* DIMENSIONAMENTO DELLE STRUTTURE DATI DEL PRODOTTO CARTESIANO */

#ifdef SIMULATION
 fill_preselection_rate_field();
/* CREAZIONE STRUTTURE DATI PER LE STATISTICHE E LETTURA FILE .stat */
 create_statistics_data_structure(ok);	   /* OPERAZIONI */
/* CREAZIONE STRUTTURE DATI PER LE STATISTICHE E LETTURA FILE .stat */
#endif

 create_marking_data_structure();    /* OPERAZIONI */
 fill_marking_data_structure();	     /* OPERAZIONI */

 fclose(kkin);
 fclose(kkout);
 fclose(mfp);
 fclose(pinfp);
 remove_command(comm,argv[1],"mfp");
 system(comm);
 remove_command(comm,argv[1],"par");
 system(comm);

/* LETTURA DEL FILE .net E DELLA MARCATURA INIZIALE */

/* CALCOLO RELAZIONI cc E sc E SCRITTURA  SUI RELATIVI FILE */

 compose_name(net,argv[1],"cc");
 cfp = efopen(net,"w");
 compose_name(net,argv[1],"sc");
 sfp = efopen(net,"w");

 get_CC_SC_relations();	      /* OPERAZIONI */

 fclose(cfp);
 fclose(sfp);

/* CALCOLO RELAZIONI cc E sc E SCRITTURA  SUI RELATIVI FILE */

/* LETTURA DEI FILE .sc,.cc,.me E CREAZIONE DELLE RELATIVE STRUTTURE DATI */

 compose_name(net,argv[1],"cc");
 cfp=efopen(net,"r");
 compose_name(net,argv[1],"sc");
 sfp=efopen(net,"r");

 fill_CC_SC_data_structure(FALSE);    /* OPERAZIONI */


 fclose(cfp);
 fclose(sfp);

/* LETTURA DEI FILE .sc,.cc,.me E CREAZIONE DELLE RELATIVE STRUTTURE DATI */
#ifdef DSDR
N_STAZ = tabc[0].card;
M_DIST = net_mark[5].total / N_STAZ;
#endif
#ifdef SYMBOLIC
 initialize_split_data_structure();
 initialize_merge_data_structure();
#endif
#ifdef SIMULATION
 init_events(); /* OPERAZIONI */
 forward_sim(argv[1],first_tr_l,tr_l,min_b,max_b,appr,conf_l);	 /* OPERAZIONI */
#endif
#ifdef REACHABILITY
 if(output_flag)
  {/* Creazione del file srg */
   compose_name(net,argv[1],"srg");
   for(ii = 0;ii < ncl ; ii++)
    {
     sprintf(str,"%s%d",tabc[ii].col_name,tabc[ii].card);
     strcat(net,str);
    }
   srg = efopen(net,"w") ;
  }/* Creazione del file srg */
 compose_name(net,argv[1],"wngr");
 wngr = efopen(net,"w") ;
 compose_name(net,argv[1],"rgr_aux");
 rgr_aux = efopen(net,"w") ;
 compose_name(net,argv[1],"ctrs");
 ctrs = efopen(net,"w") ;
 compose_name(net,argv[1],"grg");
 grg = efopen(net,"w") ;
 compose_name(net,argv[1],"string");
 string = efopen(net,"w") ;
 fclose(string);
 compose_name(net,argv[1],"string");
 string = efopen(net,"r+") ;
#ifdef SYMBOLIC
 compose_name(net,argv[1],"cap");
 f_cap_fp = efopen(net,"w") ;
 fclose(f_cap_fp);
 f_cap_fp = efopen(net,"r+") ;
 compose_name(net,argv[1],"val");
 value_fp = efopen(net,"w") ;
 fclose(value_fp);
 value_fp = efopen(net,"r+") ;
 compose_name(net,argv[1],"minval");
 min_value_fp = efopen(net,"w") ;
 fclose(min_value_fp);
 min_value_fp = efopen(net,"r+") ;
#endif

 build_graph(); 				      /* OPERAZIONI */

 if(output_flag)
  fclose(srg);
 fclose(rgr_aux);
 fclose(wngr);
 fclose(ctrs);
 fclose(grg);
 fclose(string);
#ifdef SYMBOLIC
 fclose(f_cap_fp);
 fclose(value_fp);
 fclose(min_value_fp);
#endif
#endif

#ifdef DEBUG_malloc
#ifdef SIMULATION
 out_times_info();
#endif
#ifdef REACHABILITY
 out_reach_info();
#ifdef SYMBOLIC
 out_canonic_info();
#endif
#endif
 out_token_info();
 out_event_info();
#endif
 return 0;
}
