# include <stdio.h>
# include "../../INCLUDE/const.h"
#ifdef SYMBOLIC
# include "../../INCLUDE/struct.h"
# include "../../INCLUDE/var_ext.h"
# include "../../INCLUDE/fun_ext.h"
# include "../../INCLUDE/macros.h"

extern int get_random_integer();
int ** nos = NULL;
int ** nofs = NULL;
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
void initialize_split_data_structure()
 {/* Init initialize_split_data_structure */
  int ii;

  if (ncl != 0)
   {
    nos = (int **)ecalloc(ncl,sizeof(int *));
    nofs = (int **)ecalloc(ncl,sizeof(int *));
    for(ii = 0; ii < ncl; ii++)
     if(IS_UNORDERED(ii))
      if(GET_STATIC_SUBCLASS(ii))
       {
        nos[ii] = (int *)ecalloc(GET_STATIC_SUBCLASS(ii),sizeof(int));
        nofs[ii] = (int *)ecalloc(GET_STATIC_SUBCLASS(ii),sizeof(int));
       }
   }
 }/* End initialize_split_data_structure */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void get_pointer_info_not_from_scratch(start_ptr, add_ptr , pl , ret_ptr)
 Token_p start_ptr;
 Token_p add_ptr;
 int pl;
 TokInfo_p ret_ptr;
 {/* Init get_pointer_info_not_from_scratch */
  Token_p pos_ptr = NULL;
  Token_p prv_ptr = NULL;

  int domain_comp;
  int status = 0;

  domain_comp = GET_PLACE_COMPONENTS(pl);
  ret_ptr->pos = ret_ptr->prv = NULL;
  if(IS_NEUTRAL(pl))
   {/* Posto neutro */
    ret_ptr->pos = net_mark[pl].marking;
   }/* Posto neutro */
   else
    {/* Posto colorato */
     if(IS_FULL(pl))
      {/* C'e' almeno un token */
       for(pos_ptr = start_ptr; pos_ptr != NULL ; pos_ptr = pos_ptr->next)
	{/* Per ogni token della marcatura di pl */
	 status = optimized_compare_token_id(add_ptr->id , pos_ptr->id , pl);
	 switch(status)
	  {
	   case EQUAL_TO     : ret_ptr->pos = pos_ptr;
			       ret_ptr->prv = prv_ptr;
			       goto ok;
	   case LESSER_THAN  : ret_ptr->pos = NULL;
			       ret_ptr->prv = prv_ptr;
			       goto ok;
	   case GREATER_THAN : break;
	  }
	 prv_ptr = pos_ptr;
	 ret_ptr->prv = prv_ptr;
	}/* Per ogni token della marcatura di pl */
      }/* C'e' almeno un token */
    }/* Posto colorato */
ok:return;
 }/* End get_pointer_info_not_from_scratch */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void split_of_marking(pl,fix,src,dst)
 int pl;
 int fix;
 int src;
 int dst;
 {/* Init split_of_marking */
  int over = FALSE;
  Token_p tok_ptr = net_mark[pl].marking;
  Token_p add_ptr = NULL;

  struct TOKEN_INFO result;
  TokInfo_p res_ptr = &result;

  for(; tok_ptr != NULL && !over; )
   {/* Per ogni token nella marcatura di pl */
    if(tok_ptr->id[fix] == src)
     {/* Da duplicare */
      (net_mark[pl].different)++;
      add_ptr = pop_token(pl);
      optimized_init_token_values(tok_ptr->id,add_ptr,pl);
      add_ptr->id[fix] = dst;
      SET_TOKEN_MOLTEPLICITY(tok_ptr->molt,add_ptr);
      get_pointer_info_not_from_scratch(tok_ptr, add_ptr , pl , res_ptr);
      insert_token(res_ptr,add_ptr,pl);
     }/* Da duplicare */
    tok_ptr = NEXT_TOKEN(tok_ptr);
   }/* Per ogni token nella marcatura di pl */
 }/* End split_of_marking */
/**************************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**************************************************************/
static void copy_marking_distribution(cl,ss,src,dst)
 int cl;
 int ss;
 int src;
 int dst;
 {/* Init copy_marking_distribution */
  int pl,fix;

  for(pl = 0 ; pl < npl ; pl++)
   {/* Splitting marcatura in ogni posto */
    if(IS_FULL(pl))
     {/* Se il posto e'pieno */
      if(IS_COLOURED(pl))
       {/* se il posto e' colorato */
	for(fix = 0 ; fix < GET_PLACE_COMPONENTS(pl) ; fix++)
	 if(GET_COLOR_COMPONENT(fix,pl) == cl)
	  split_of_marking(pl,fix,src,dst);
       } /* se il posto e' colorato */
     }/* Se il posto e'pieno */
   }/* Splitting marcatura in ogni posto */
 }/* End copy_marking_distribution */
#ifdef SIMULATION
/**********************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**********************************************************/
static void fix_split_elements(instance_ptr)
 Event_p instance_ptr;
 {/* Init fix_split_elements */
  int tr = GET_TRANSITION_INDEX(instance_ptr);
  int pos,prv,base,n_ist,random_id;
  int cl,ss,ds;

  for( cl = ncl; cl ; cl--)
   {/* Per ogni classe */
    if(IS_UNORDERED(cl - 1))
     {/* Classe non ordinata */
      if(tabt[tr].rip[cl - 1])
       {/* La classe e' presente nel dominio della transizione */
        if(tabt[tr].split_type[cl - 1] == AT_FIRING_TIME)
         {/* Si puo' fare lo split ritardato */
	  base = tabt[tr].off[cl - 1];
	  for( pos = 0 ; pos < tabt[tr].rip[cl - 1] ; pos++)
	   {/* Per ogni ripetizione nel dominio della transizione */
	    ds = GET_DYN_ID(instance_ptr,base + pos);
	    ss = get_static_subclass(cl - 1,ds);
	    n_ist = 0;
	    for(prv = 0; prv < pos ; prv++)
	     n_ist += (GET_DYN_ID(instance_ptr,base + prv) == ds);
	    random_id = get_random_integer(1,GET_CARD(cl - 1,ss,ds));
	    if(random_id > n_ist)
	     instance_ptr->split[base + pos] = ENCODE_ID(ds,n_ist);
	    else
	     instance_ptr->split[base + pos] = ENCODE_ID(ds,random_id - 1);
	   }/* Per ogni ripetizione nel dominio della transizione */
         }/* Si puo' fare lo split ritardato */
       }/* La classe e' presente nel dominio della transizione */
     }/* Classe non ordinata */
   }/* Per ogni classe */
 }/* End fix_split_elements */
#endif
/**********************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**********************************************************/
static int already_split(ds,pos,cl,tr,ev_p)
 int ds;
 int pos;
 int cl;
 int tr;
 Event_p ev_p;
 {/* Init already_split */
  int ret_value = FALSE;
  int start = OFF(tr,cl);

  for(; start < pos ; start++)
   if(ds == ev_p->split[start])
    {
     ret_value = TRUE;
     goto ret;
    }
ret:return(ret_value);
 }/* End already_split */
/**********************************************************/
/* NAME : */
/* DESCRIPTION : */
/* PARAMETERS : */
/* RETURN VALUE : */
/**********************************************************/
void split(instance_ptr)
Event_p instance_ptr;
 { /* Init split */
  int i,cl,ss,ds,nds;
  int tr = GET_TRANSITION_INDEX(instance_ptr);
  int comp = GET_TRANSITION_COMPONENTS(tr);
  int split_id;

  for(cl = 0; cl < ncl; cl++)
   if(IS_UNORDERED(cl))
    for(ss = 0 ; ss < GET_STATIC_SUBCLASS(cl); ss++)
     nos[cl][ss] = nofs[cl][ss] = 0;
#ifdef SIMULATION
  fix_split_elements(instance_ptr);
#endif
  for (i = 0 ; i < comp; i++)
   {/* per ogni componente del dominio della transizione */
    cl = GET_COLOR_IN_POSITION(i,tr);
    if(IS_UNORDERED(cl))
     {/* Classe non ordinata */
      split_id = GET_SPLIT_ID(instance_ptr,i);
      if(!already_split(split_id,i,cl,tr,instance_ptr))
       {/* Non analizzata in precedenza */
        ds = GET_DYN_ID(instance_ptr,i);
        ss = get_static_subclass(cl,ds);
        nos[cl][ss]++;
        if (GET_CARD(cl,ss,ds) > 1)
         {/* sottoclasse con card. > 1 */
	  instance_ptr->split[i] = nds = tabc[cl].sbclist[ss].offset + GET_NEW_ID(cl,ss);
	  DECREASE_CARD(cl,ss,ds-tabc[cl].sbclist[ss].offset,1);
	  SET_CARD(cl,ss,GET_NEW_ID(cl,ss),1);
	  INCREASE_NUM_SS(cl,ss);
	  INCREASE_NUM_CL(cl);
	  nofs[cl][ss]++;
	  copy_marking_distribution(cl,ss,ds,nds);
         } /* sottoclasse con card. > 1 */
        else
         { /* sottoclasse con card. = 1 */
	  instance_ptr->split[i] = instance_ptr->npla[i];
         } /* sottoclasse con card. = 1 */
       }/* Non analizzata in precedenza */
     }/* Classe non ordinata */
    else
     instance_ptr->split[i] = instance_ptr->npla[i];
   } /* per ogni componente del dominio della transizione */
 } /* End split */
#endif
